Index: pjproject/trunk/build.symbian/pjsip_uaU.def
===================================================================
--- pjproject/trunk/build.symbian/pjsip_uaU.def	(revision 1568)
+++ pjproject/trunk/build.symbian/pjsip_uaU.def	(revision 1603)
@@ -13,45 +13,46 @@
 	pjsip_get_refer_method                   @ 12 NONAME
 	pjsip_inv_answer                         @ 13 NONAME
-	pjsip_inv_create_uac                     @ 14 NONAME
-	pjsip_inv_create_uas                     @ 15 NONAME
-	pjsip_inv_end_session                    @ 16 NONAME
-	pjsip_inv_initial_answer                 @ 17 NONAME
-	pjsip_inv_invite                         @ 18 NONAME
-	pjsip_inv_reinvite                       @ 19 NONAME
-	pjsip_inv_send_msg                       @ 20 NONAME
-	pjsip_inv_set_sdp_answer                 @ 21 NONAME
-	pjsip_inv_state_name                     @ 22 NONAME
-	pjsip_inv_terminate                      @ 23 NONAME
-	pjsip_inv_update                         @ 24 NONAME
-	pjsip_inv_usage_init                     @ 25 NONAME
-	pjsip_inv_usage_instance                 @ 26 NONAME
-	pjsip_inv_verify_request                 @ 27 NONAME
-	pjsip_prack_method                       @ 28 NONAME
-	pjsip_refer_method                       @ 29 NONAME
-	pjsip_regc_add_headers                   @ 30 NONAME
-	pjsip_regc_create                        @ 31 NONAME
-	pjsip_regc_destroy                       @ 32 NONAME
-	pjsip_regc_get_info                      @ 33 NONAME
-	pjsip_regc_get_pool                      @ 34 NONAME
-	pjsip_regc_init                          @ 35 NONAME
-	pjsip_regc_register                      @ 36 NONAME
-	pjsip_regc_send                          @ 37 NONAME
-	pjsip_regc_set_credentials               @ 38 NONAME
-	pjsip_regc_set_prefs                     @ 39 NONAME
-	pjsip_regc_set_route_set                 @ 40 NONAME
-	pjsip_regc_set_transport                 @ 41 NONAME
-	pjsip_regc_unregister                    @ 42 NONAME
-	pjsip_regc_unregister_all                @ 43 NONAME
-	pjsip_regc_update_contact                @ 44 NONAME
-	pjsip_regc_update_expires                @ 45 NONAME
-	pjsip_replaces_hdr_create                @ 46 NONAME
-	pjsip_replaces_init_module               @ 47 NONAME
-	pjsip_replaces_verify_request            @ 48 NONAME
-	pjsip_xfer_accept                        @ 49 NONAME
-	pjsip_xfer_create_uac                    @ 50 NONAME
-	pjsip_xfer_create_uas                    @ 51 NONAME
-	pjsip_xfer_current_notify                @ 52 NONAME
-	pjsip_xfer_init_module                   @ 53 NONAME
-	pjsip_xfer_initiate                      @ 54 NONAME
-	pjsip_xfer_notify                        @ 55 NONAME
-	pjsip_xfer_send_request                  @ 56 NONAME
+	pjsip_inv_create_ack                     @ 14 NONAME
+	pjsip_inv_create_uac                     @ 15 NONAME
+	pjsip_inv_create_uas                     @ 16 NONAME
+	pjsip_inv_end_session                    @ 17 NONAME
+	pjsip_inv_initial_answer                 @ 18 NONAME
+	pjsip_inv_invite                         @ 19 NONAME
+	pjsip_inv_reinvite                       @ 20 NONAME
+	pjsip_inv_send_msg                       @ 21 NONAME
+	pjsip_inv_set_sdp_answer                 @ 22 NONAME
+	pjsip_inv_state_name                     @ 23 NONAME
+	pjsip_inv_terminate                      @ 24 NONAME
+	pjsip_inv_update                         @ 25 NONAME
+	pjsip_inv_usage_init                     @ 26 NONAME
+	pjsip_inv_usage_instance                 @ 27 NONAME
+	pjsip_inv_verify_request                 @ 28 NONAME
+	pjsip_prack_method                       @ 29 NONAME
+	pjsip_refer_method                       @ 30 NONAME
+	pjsip_regc_add_headers                   @ 31 NONAME
+	pjsip_regc_create                        @ 32 NONAME
+	pjsip_regc_destroy                       @ 33 NONAME
+	pjsip_regc_get_info                      @ 34 NONAME
+	pjsip_regc_get_pool                      @ 35 NONAME
+	pjsip_regc_init                          @ 36 NONAME
+	pjsip_regc_register                      @ 37 NONAME
+	pjsip_regc_send                          @ 38 NONAME
+	pjsip_regc_set_credentials               @ 39 NONAME
+	pjsip_regc_set_prefs                     @ 40 NONAME
+	pjsip_regc_set_route_set                 @ 41 NONAME
+	pjsip_regc_set_transport                 @ 42 NONAME
+	pjsip_regc_unregister                    @ 43 NONAME
+	pjsip_regc_unregister_all                @ 44 NONAME
+	pjsip_regc_update_contact                @ 45 NONAME
+	pjsip_regc_update_expires                @ 46 NONAME
+	pjsip_replaces_hdr_create                @ 47 NONAME
+	pjsip_replaces_init_module               @ 48 NONAME
+	pjsip_replaces_verify_request            @ 49 NONAME
+	pjsip_xfer_accept                        @ 50 NONAME
+	pjsip_xfer_create_uac                    @ 51 NONAME
+	pjsip_xfer_create_uas                    @ 52 NONAME
+	pjsip_xfer_current_notify                @ 53 NONAME
+	pjsip_xfer_init_module                   @ 54 NONAME
+	pjsip_xfer_initiate                      @ 55 NONAME
+	pjsip_xfer_notify                        @ 56 NONAME
+	pjsip_xfer_send_request                  @ 57 NONAME