Index: pjproject/trunk/build.symbian/pjlibU.def
===================================================================
--- pjproject/trunk/build.symbian/pjlibU.def	(revision 1608)
+++ pjproject/trunk/build.symbian/pjlibU.def	(revision 1609)
@@ -115,201 +115,203 @@
 	pj_inet_ntoa                             @ 114 NONAME
 	pj_inet_ntop                             @ 115 NONAME
-	pj_inet_pton                             @ 116 NONAME
-	pj_init                                  @ 117 NONAME
-	pj_ioqueue_accept                        @ 118 NONAME
-	pj_ioqueue_connect                       @ 119 NONAME
-	pj_ioqueue_create                        @ 120 NONAME
-	pj_ioqueue_destroy                       @ 121 NONAME
-	pj_ioqueue_get_user_data                 @ 122 NONAME
-	pj_ioqueue_is_pending                    @ 123 NONAME
-	pj_ioqueue_name                          @ 124 NONAME
-	pj_ioqueue_op_key_init                   @ 125 NONAME
-	pj_ioqueue_poll                          @ 126 NONAME
-	pj_ioqueue_post_completion               @ 127 NONAME
-	pj_ioqueue_recv                          @ 128 NONAME
-	pj_ioqueue_recvfrom                      @ 129 NONAME
-	pj_ioqueue_register_sock                 @ 130 NONAME
-	pj_ioqueue_send                          @ 131 NONAME
-	pj_ioqueue_sendto                        @ 132 NONAME
-	pj_ioqueue_set_lock                      @ 133 NONAME
-	pj_ioqueue_set_user_data                 @ 134 NONAME
-	pj_ioqueue_unregister                    @ 135 NONAME
-	pj_leave_critical_section                @ 136 NONAME
-	pj_list_erase                            @ 137 NONAME
-	pj_list_find_node                        @ 138 NONAME
-	pj_list_insert_after                     @ 139 NONAME
-	pj_list_insert_before                    @ 140 NONAME
-	pj_list_insert_nodes_after               @ 141 NONAME
-	pj_list_insert_nodes_before              @ 142 NONAME
-	pj_list_merge_first                      @ 143 NONAME
-	pj_list_merge_last                       @ 144 NONAME
-	pj_list_search                           @ 145 NONAME
-	pj_list_size                             @ 146 NONAME
-	pj_lock_acquire                          @ 147 NONAME
-	pj_lock_create_null_mutex                @ 148 NONAME
-	pj_lock_create_recursive_mutex           @ 149 NONAME
-	pj_lock_create_semaphore                 @ 150 NONAME
-	pj_lock_create_simple_mutex              @ 151 NONAME
-	pj_lock_destroy                          @ 152 NONAME
-	pj_lock_release                          @ 153 NONAME
-	pj_lock_tryacquire                       @ 154 NONAME
-	pj_log                                   @ 155 NONAME
-	pj_log_1                                 @ 156 NONAME
-	pj_log_2                                 @ 157 NONAME
-	pj_log_3                                 @ 158 NONAME
-	pj_log_4                                 @ 159 NONAME
-	pj_log_5                                 @ 160 NONAME
-	pj_log_get_decor                         @ 161 NONAME
-	pj_log_get_level                         @ 162 NONAME
-	pj_log_get_log_func                      @ 163 NONAME
-	pj_log_set_decor                         @ 164 NONAME
-	pj_log_set_level                         @ 165 NONAME
-	pj_log_set_log_func                      @ 166 NONAME
-	pj_log_write                             @ 167 NONAME
-	pj_mutex_create                          @ 168 NONAME
-	pj_mutex_create_recursive                @ 169 NONAME
-	pj_mutex_create_simple                   @ 170 NONAME
-	pj_mutex_destroy                         @ 171 NONAME
-	pj_mutex_lock                            @ 172 NONAME
-	pj_mutex_trylock                         @ 173 NONAME
-	pj_mutex_unlock                          @ 174 NONAME
-	pj_ntohl                                 @ 175 NONAME
-	pj_ntohs                                 @ 176 NONAME
-	pj_pool_alloc                            @ 177 NONAME
-	pj_pool_alloc_from_block                 @ 178 NONAME
-	pj_pool_allocate_find                    @ 179 NONAME
-	pj_pool_calloc                           @ 180 NONAME
-	pj_pool_create                           @ 181 NONAME
-	pj_pool_create_int                       @ 182 NONAME
-	pj_pool_create_on_buf                    @ 183 NONAME
-	pj_pool_destroy_int                      @ 184 NONAME
-	pj_pool_factory_default_policy           @ 185 NONAME
-	pj_pool_factory_get_default_policy       @ 186 NONAME
-	pj_pool_get_capacity                     @ 187 NONAME
-	pj_pool_get_used_size                    @ 188 NONAME
-	pj_pool_getobjname                       @ 189 NONAME
-	pj_pool_init_int                         @ 190 NONAME
-	pj_pool_release                          @ 191 NONAME
-	pj_pool_reset                            @ 192 NONAME
-	pj_rand                                  @ 193 NONAME
-	pj_rbtree_erase                          @ 194 NONAME
-	pj_rbtree_find                           @ 195 NONAME
-	pj_rbtree_first                          @ 196 NONAME
-	pj_rbtree_init                           @ 197 NONAME
-	pj_rbtree_insert                         @ 198 NONAME
-	pj_rbtree_last                           @ 199 NONAME
-	pj_rbtree_max_height                     @ 200 NONAME
-	pj_rbtree_min_height                     @ 201 NONAME
-	pj_rbtree_next                           @ 202 NONAME
-	pj_rbtree_prev                           @ 203 NONAME
-	pj_register_strerror                     @ 204 NONAME
-	pj_rwmutex_create                        @ 205 NONAME
-	pj_rwmutex_destroy                       @ 206 NONAME
-	pj_rwmutex_lock_read                     @ 207 NONAME
-	pj_rwmutex_lock_write                    @ 208 NONAME
-	pj_rwmutex_unlock_read                   @ 209 NONAME
-	pj_rwmutex_unlock_write                  @ 210 NONAME
-	pj_sem_create                            @ 211 NONAME
-	pj_sem_destroy                           @ 212 NONAME
-	pj_sem_post                              @ 213 NONAME
-	pj_sem_trywait                           @ 214 NONAME
-	pj_sem_wait                              @ 215 NONAME
-	pj_set_netos_error                       @ 216 NONAME
-	pj_set_os_error                          @ 217 NONAME
-	pj_shutdown                              @ 218 NONAME
-	pj_sock_accept                           @ 219 NONAME
-	pj_sock_bind                             @ 220 NONAME
-	pj_sock_bind_in                          @ 221 NONAME
-	pj_sock_close                            @ 222 NONAME
-	pj_sock_connect                          @ 223 NONAME
-	pj_sock_getpeername                      @ 224 NONAME
-	pj_sock_getsockname                      @ 225 NONAME
-	pj_sock_getsockopt                       @ 226 NONAME
-	pj_sock_listen                           @ 227 NONAME
-	pj_sock_recv                             @ 228 NONAME
-	pj_sock_recvfrom                         @ 229 NONAME
-	pj_sock_select                           @ 230 NONAME
-	pj_sock_send                             @ 231 NONAME
-	pj_sock_sendto                           @ 232 NONAME
-	pj_sock_setsockopt                       @ 233 NONAME
-	pj_sock_shutdown                         @ 234 NONAME
-	pj_sock_socket                           @ 235 NONAME
-	pj_sockaddr_get_addr                     @ 236 NONAME
-	pj_sockaddr_get_addr_len                 @ 237 NONAME
-	pj_sockaddr_get_port                     @ 238 NONAME
-	pj_sockaddr_has_addr                     @ 239 NONAME
-	pj_sockaddr_in_get_addr                  @ 240 NONAME
-	pj_sockaddr_in_get_port                  @ 241 NONAME
-	pj_sockaddr_in_init                      @ 242 NONAME
-	pj_sockaddr_in_set_addr                  @ 243 NONAME
-	pj_sockaddr_in_set_port                  @ 244 NONAME
-	pj_sockaddr_in_set_str_addr              @ 245 NONAME
-	pj_sockaddr_init                         @ 246 NONAME
-	pj_sockaddr_set_port                     @ 247 NONAME
-	pj_sockaddr_set_str_addr                 @ 248 NONAME
-	pj_srand                                 @ 249 NONAME
-	pj_str                                   @ 250 NONAME
-	pj_strassign                             @ 251 NONAME
-	pj_strcat                                @ 252 NONAME
-	pj_strcat2                               @ 253 NONAME
-	pj_strcmp                                @ 254 NONAME
-	pj_strcmp2                               @ 255 NONAME
-	pj_strcpy                                @ 256 NONAME
-	pj_strcpy2                               @ 257 NONAME
-	pj_strdup                                @ 258 NONAME
-	pj_strdup2                               @ 259 NONAME
-	pj_strdup2_with_null                     @ 260 NONAME
-	pj_strdup3                               @ 261 NONAME
-	pj_strdup_with_null                      @ 262 NONAME
-	pj_strerror                              @ 263 NONAME
-	pj_stricmp                               @ 264 NONAME
-	pj_stricmp2                              @ 265 NONAME
-	pj_strltrim                              @ 266 NONAME
-	pj_strncmp                               @ 267 NONAME
-	pj_strncmp2                              @ 268 NONAME
-	pj_strncpy                               @ 269 NONAME
-	pj_strncpy_with_null                     @ 270 NONAME
-	pj_strnicmp                              @ 271 NONAME
-	pj_strnicmp2                             @ 272 NONAME
-	pj_strrtrim                              @ 273 NONAME
-	pj_strtoul                               @ 274 NONAME
-	pj_strtoul2                              @ 275 NONAME
-	pj_strtrim                               @ 276 NONAME
-	pj_symbianos_poll                        @ 277 NONAME
-	pj_symbianos_set_params                  @ 278 NONAME
-	pj_thread_create                         @ 279 NONAME
-	pj_thread_destroy                        @ 280 NONAME
-	pj_thread_get_name                       @ 281 NONAME
-	pj_thread_get_os_handle                  @ 282 NONAME
-	pj_thread_is_registered                  @ 283 NONAME
-	pj_thread_join                           @ 284 NONAME
-	pj_thread_local_alloc                    @ 285 NONAME
-	pj_thread_local_free                     @ 286 NONAME
-	pj_thread_local_get                      @ 287 NONAME
-	pj_thread_local_set                      @ 288 NONAME
-	pj_thread_register                       @ 289 NONAME
-	pj_thread_resume                         @ 290 NONAME
-	pj_thread_sleep                          @ 291 NONAME
-	pj_thread_this                           @ 292 NONAME
-	pj_time_decode                           @ 293 NONAME
-	pj_time_encode                           @ 294 NONAME
-	pj_time_gmt_to_local                     @ 295 NONAME
-	pj_time_local_to_gmt                     @ 296 NONAME
-	pj_time_val_normalize                    @ 297 NONAME
-	pj_timer_entry_init                      @ 298 NONAME
-	pj_timer_heap_cancel                     @ 299 NONAME
-	pj_timer_heap_count                      @ 300 NONAME
-	pj_timer_heap_create                     @ 301 NONAME
-	pj_timer_heap_destroy                    @ 302 NONAME
-	pj_timer_heap_earliest_time              @ 303 NONAME
-	pj_timer_heap_mem_size                   @ 304 NONAME
-	pj_timer_heap_poll                       @ 305 NONAME
-	pj_timer_heap_schedule                   @ 306 NONAME
-	pj_timer_heap_set_lock                   @ 307 NONAME
-	pj_timer_heap_set_max_timed_out_per_poll @ 308 NONAME
-	pj_unicode_to_ansi                       @ 309 NONAME
-	pj_utoa                                  @ 310 NONAME
-	pj_utoa_pad                              @ 311 NONAME
-	platform_strerror                        @ 312 NONAME
-	snprintf                                 @ 313 NONAME
-	vsnprintf                                @ 314 NONAME
+	pj_inet_ntop2                            @ 116 NONAME
+	pj_inet_pton                             @ 117 NONAME
+	pj_init                                  @ 118 NONAME
+	pj_ioqueue_accept                        @ 119 NONAME
+	pj_ioqueue_connect                       @ 120 NONAME
+	pj_ioqueue_create                        @ 121 NONAME
+	pj_ioqueue_destroy                       @ 122 NONAME
+	pj_ioqueue_get_user_data                 @ 123 NONAME
+	pj_ioqueue_is_pending                    @ 124 NONAME
+	pj_ioqueue_name                          @ 125 NONAME
+	pj_ioqueue_op_key_init                   @ 126 NONAME
+	pj_ioqueue_poll                          @ 127 NONAME
+	pj_ioqueue_post_completion               @ 128 NONAME
+	pj_ioqueue_recv                          @ 129 NONAME
+	pj_ioqueue_recvfrom                      @ 130 NONAME
+	pj_ioqueue_register_sock                 @ 131 NONAME
+	pj_ioqueue_send                          @ 132 NONAME
+	pj_ioqueue_sendto                        @ 133 NONAME
+	pj_ioqueue_set_lock                      @ 134 NONAME
+	pj_ioqueue_set_user_data                 @ 135 NONAME
+	pj_ioqueue_unregister                    @ 136 NONAME
+	pj_leave_critical_section                @ 137 NONAME
+	pj_list_erase                            @ 138 NONAME
+	pj_list_find_node                        @ 139 NONAME
+	pj_list_insert_after                     @ 140 NONAME
+	pj_list_insert_before                    @ 141 NONAME
+	pj_list_insert_nodes_after               @ 142 NONAME
+	pj_list_insert_nodes_before              @ 143 NONAME
+	pj_list_merge_first                      @ 144 NONAME
+	pj_list_merge_last                       @ 145 NONAME
+	pj_list_search                           @ 146 NONAME
+	pj_list_size                             @ 147 NONAME
+	pj_lock_acquire                          @ 148 NONAME
+	pj_lock_create_null_mutex                @ 149 NONAME
+	pj_lock_create_recursive_mutex           @ 150 NONAME
+	pj_lock_create_semaphore                 @ 151 NONAME
+	pj_lock_create_simple_mutex              @ 152 NONAME
+	pj_lock_destroy                          @ 153 NONAME
+	pj_lock_release                          @ 154 NONAME
+	pj_lock_tryacquire                       @ 155 NONAME
+	pj_log                                   @ 156 NONAME
+	pj_log_1                                 @ 157 NONAME
+	pj_log_2                                 @ 158 NONAME
+	pj_log_3                                 @ 159 NONAME
+	pj_log_4                                 @ 160 NONAME
+	pj_log_5                                 @ 161 NONAME
+	pj_log_get_decor                         @ 162 NONAME
+	pj_log_get_level                         @ 163 NONAME
+	pj_log_get_log_func                      @ 164 NONAME
+	pj_log_set_decor                         @ 165 NONAME
+	pj_log_set_level                         @ 166 NONAME
+	pj_log_set_log_func                      @ 167 NONAME
+	pj_log_write                             @ 168 NONAME
+	pj_mutex_create                          @ 169 NONAME
+	pj_mutex_create_recursive                @ 170 NONAME
+	pj_mutex_create_simple                   @ 171 NONAME
+	pj_mutex_destroy                         @ 172 NONAME
+	pj_mutex_lock                            @ 173 NONAME
+	pj_mutex_trylock                         @ 174 NONAME
+	pj_mutex_unlock                          @ 175 NONAME
+	pj_ntohl                                 @ 176 NONAME
+	pj_ntohs                                 @ 177 NONAME
+	pj_pool_alloc                            @ 178 NONAME
+	pj_pool_alloc_from_block                 @ 179 NONAME
+	pj_pool_allocate_find                    @ 180 NONAME
+	pj_pool_calloc                           @ 181 NONAME
+	pj_pool_create                           @ 182 NONAME
+	pj_pool_create_int                       @ 183 NONAME
+	pj_pool_create_on_buf                    @ 184 NONAME
+	pj_pool_destroy_int                      @ 185 NONAME
+	pj_pool_factory_default_policy           @ 186 NONAME
+	pj_pool_factory_get_default_policy       @ 187 NONAME
+	pj_pool_get_capacity                     @ 188 NONAME
+	pj_pool_get_used_size                    @ 189 NONAME
+	pj_pool_getobjname                       @ 190 NONAME
+	pj_pool_init_int                         @ 191 NONAME
+	pj_pool_release                          @ 192 NONAME
+	pj_pool_reset                            @ 193 NONAME
+	pj_rand                                  @ 194 NONAME
+	pj_rbtree_erase                          @ 195 NONAME
+	pj_rbtree_find                           @ 196 NONAME
+	pj_rbtree_first                          @ 197 NONAME
+	pj_rbtree_init                           @ 198 NONAME
+	pj_rbtree_insert                         @ 199 NONAME
+	pj_rbtree_last                           @ 200 NONAME
+	pj_rbtree_max_height                     @ 201 NONAME
+	pj_rbtree_min_height                     @ 202 NONAME
+	pj_rbtree_next                           @ 203 NONAME
+	pj_rbtree_prev                           @ 204 NONAME
+	pj_register_strerror                     @ 205 NONAME
+	pj_rwmutex_create                        @ 206 NONAME
+	pj_rwmutex_destroy                       @ 207 NONAME
+	pj_rwmutex_lock_read                     @ 208 NONAME
+	pj_rwmutex_lock_write                    @ 209 NONAME
+	pj_rwmutex_unlock_read                   @ 210 NONAME
+	pj_rwmutex_unlock_write                  @ 211 NONAME
+	pj_sem_create                            @ 212 NONAME
+	pj_sem_destroy                           @ 213 NONAME
+	pj_sem_post                              @ 214 NONAME
+	pj_sem_trywait                           @ 215 NONAME
+	pj_sem_wait                              @ 216 NONAME
+	pj_set_netos_error                       @ 217 NONAME
+	pj_set_os_error                          @ 218 NONAME
+	pj_shutdown                              @ 219 NONAME
+	pj_sock_accept                           @ 220 NONAME
+	pj_sock_bind                             @ 221 NONAME
+	pj_sock_bind_in                          @ 222 NONAME
+	pj_sock_close                            @ 223 NONAME
+	pj_sock_connect                          @ 224 NONAME
+	pj_sock_getpeername                      @ 225 NONAME
+	pj_sock_getsockname                      @ 226 NONAME
+	pj_sock_getsockopt                       @ 227 NONAME
+	pj_sock_listen                           @ 228 NONAME
+	pj_sock_recv                             @ 229 NONAME
+	pj_sock_recvfrom                         @ 230 NONAME
+	pj_sock_select                           @ 231 NONAME
+	pj_sock_send                             @ 232 NONAME
+	pj_sock_sendto                           @ 233 NONAME
+	pj_sock_setsockopt                       @ 234 NONAME
+	pj_sock_shutdown                         @ 235 NONAME
+	pj_sock_socket                           @ 236 NONAME
+	pj_sockaddr_get_addr                     @ 237 NONAME
+	pj_sockaddr_get_addr_len                 @ 238 NONAME
+	pj_sockaddr_get_len                      @ 239 NONAME
+	pj_sockaddr_get_port                     @ 240 NONAME
+	pj_sockaddr_has_addr                     @ 241 NONAME
+	pj_sockaddr_in_get_addr                  @ 242 NONAME
+	pj_sockaddr_in_get_port                  @ 243 NONAME
+	pj_sockaddr_in_init                      @ 244 NONAME
+	pj_sockaddr_in_set_addr                  @ 245 NONAME
+	pj_sockaddr_in_set_port                  @ 246 NONAME
+	pj_sockaddr_in_set_str_addr              @ 247 NONAME
+	pj_sockaddr_init                         @ 248 NONAME
+	pj_sockaddr_set_port                     @ 249 NONAME
+	pj_sockaddr_set_str_addr                 @ 250 NONAME
+	pj_srand                                 @ 251 NONAME
+	pj_str                                   @ 252 NONAME
+	pj_strassign                             @ 253 NONAME
+	pj_strcat                                @ 254 NONAME
+	pj_strcat2                               @ 255 NONAME
+	pj_strcmp                                @ 256 NONAME
+	pj_strcmp2                               @ 257 NONAME
+	pj_strcpy                                @ 258 NONAME
+	pj_strcpy2                               @ 259 NONAME
+	pj_strdup                                @ 260 NONAME
+	pj_strdup2                               @ 261 NONAME
+	pj_strdup2_with_null                     @ 262 NONAME
+	pj_strdup3                               @ 263 NONAME
+	pj_strdup_with_null                      @ 264 NONAME
+	pj_strerror                              @ 265 NONAME
+	pj_stricmp                               @ 266 NONAME
+	pj_stricmp2                              @ 267 NONAME
+	pj_strltrim                              @ 268 NONAME
+	pj_strncmp                               @ 269 NONAME
+	pj_strncmp2                              @ 270 NONAME
+	pj_strncpy                               @ 271 NONAME
+	pj_strncpy_with_null                     @ 272 NONAME
+	pj_strnicmp                              @ 273 NONAME
+	pj_strnicmp2                             @ 274 NONAME
+	pj_strrtrim                              @ 275 NONAME
+	pj_strtoul                               @ 276 NONAME
+	pj_strtoul2                              @ 277 NONAME
+	pj_strtrim                               @ 278 NONAME
+	pj_symbianos_poll                        @ 279 NONAME
+	pj_symbianos_set_params                  @ 280 NONAME
+	pj_thread_create                         @ 281 NONAME
+	pj_thread_destroy                        @ 282 NONAME
+	pj_thread_get_name                       @ 283 NONAME
+	pj_thread_get_os_handle                  @ 284 NONAME
+	pj_thread_is_registered                  @ 285 NONAME
+	pj_thread_join                           @ 286 NONAME
+	pj_thread_local_alloc                    @ 287 NONAME
+	pj_thread_local_free                     @ 288 NONAME
+	pj_thread_local_get                      @ 289 NONAME
+	pj_thread_local_set                      @ 290 NONAME
+	pj_thread_register                       @ 291 NONAME
+	pj_thread_resume                         @ 292 NONAME
+	pj_thread_sleep                          @ 293 NONAME
+	pj_thread_this                           @ 294 NONAME
+	pj_time_decode                           @ 295 NONAME
+	pj_time_encode                           @ 296 NONAME
+	pj_time_gmt_to_local                     @ 297 NONAME
+	pj_time_local_to_gmt                     @ 298 NONAME
+	pj_time_val_normalize                    @ 299 NONAME
+	pj_timer_entry_init                      @ 300 NONAME
+	pj_timer_heap_cancel                     @ 301 NONAME
+	pj_timer_heap_count                      @ 302 NONAME
+	pj_timer_heap_create                     @ 303 NONAME
+	pj_timer_heap_destroy                    @ 304 NONAME
+	pj_timer_heap_earliest_time              @ 305 NONAME
+	pj_timer_heap_mem_size                   @ 306 NONAME
+	pj_timer_heap_poll                       @ 307 NONAME
+	pj_timer_heap_schedule                   @ 308 NONAME
+	pj_timer_heap_set_lock                   @ 309 NONAME
+	pj_timer_heap_set_max_timed_out_per_poll @ 310 NONAME
+	pj_unicode_to_ansi                       @ 311 NONAME
+	pj_utoa                                  @ 312 NONAME
+	pj_utoa_pad                              @ 313 NONAME
+	platform_strerror                        @ 314 NONAME
+	snprintf                                 @ 315 NONAME
+	vsnprintf                                @ 316 NONAME