Index: pjproject/trunk/build.symbian/pjlibU.def
===================================================================
--- pjproject/trunk/build.symbian/pjlibU.def	(revision 1609)
+++ pjproject/trunk/build.symbian/pjlibU.def	(revision 1614)
@@ -236,82 +236,85 @@
 	pj_sock_shutdown                         @ 235 NONAME
 	pj_sock_socket                           @ 236 NONAME
-	pj_sockaddr_get_addr                     @ 237 NONAME
-	pj_sockaddr_get_addr_len                 @ 238 NONAME
-	pj_sockaddr_get_len                      @ 239 NONAME
-	pj_sockaddr_get_port                     @ 240 NONAME
-	pj_sockaddr_has_addr                     @ 241 NONAME
-	pj_sockaddr_in_get_addr                  @ 242 NONAME
-	pj_sockaddr_in_get_port                  @ 243 NONAME
-	pj_sockaddr_in_init                      @ 244 NONAME
-	pj_sockaddr_in_set_addr                  @ 245 NONAME
-	pj_sockaddr_in_set_port                  @ 246 NONAME
-	pj_sockaddr_in_set_str_addr              @ 247 NONAME
-	pj_sockaddr_init                         @ 248 NONAME
-	pj_sockaddr_set_port                     @ 249 NONAME
-	pj_sockaddr_set_str_addr                 @ 250 NONAME
-	pj_srand                                 @ 251 NONAME
-	pj_str                                   @ 252 NONAME
-	pj_strassign                             @ 253 NONAME
-	pj_strcat                                @ 254 NONAME
-	pj_strcat2                               @ 255 NONAME
-	pj_strcmp                                @ 256 NONAME
-	pj_strcmp2                               @ 257 NONAME
-	pj_strcpy                                @ 258 NONAME
-	pj_strcpy2                               @ 259 NONAME
-	pj_strdup                                @ 260 NONAME
-	pj_strdup2                               @ 261 NONAME
-	pj_strdup2_with_null                     @ 262 NONAME
-	pj_strdup3                               @ 263 NONAME
-	pj_strdup_with_null                      @ 264 NONAME
-	pj_strerror                              @ 265 NONAME
-	pj_stricmp                               @ 266 NONAME
-	pj_stricmp2                              @ 267 NONAME
-	pj_strltrim                              @ 268 NONAME
-	pj_strncmp                               @ 269 NONAME
-	pj_strncmp2                              @ 270 NONAME
-	pj_strncpy                               @ 271 NONAME
-	pj_strncpy_with_null                     @ 272 NONAME
-	pj_strnicmp                              @ 273 NONAME
-	pj_strnicmp2                             @ 274 NONAME
-	pj_strrtrim                              @ 275 NONAME
-	pj_strtoul                               @ 276 NONAME
-	pj_strtoul2                              @ 277 NONAME
-	pj_strtrim                               @ 278 NONAME
-	pj_symbianos_poll                        @ 279 NONAME
-	pj_symbianos_set_params                  @ 280 NONAME
-	pj_thread_create                         @ 281 NONAME
-	pj_thread_destroy                        @ 282 NONAME
-	pj_thread_get_name                       @ 283 NONAME
-	pj_thread_get_os_handle                  @ 284 NONAME
-	pj_thread_is_registered                  @ 285 NONAME
-	pj_thread_join                           @ 286 NONAME
-	pj_thread_local_alloc                    @ 287 NONAME
-	pj_thread_local_free                     @ 288 NONAME
-	pj_thread_local_get                      @ 289 NONAME
-	pj_thread_local_set                      @ 290 NONAME
-	pj_thread_register                       @ 291 NONAME
-	pj_thread_resume                         @ 292 NONAME
-	pj_thread_sleep                          @ 293 NONAME
-	pj_thread_this                           @ 294 NONAME
-	pj_time_decode                           @ 295 NONAME
-	pj_time_encode                           @ 296 NONAME
-	pj_time_gmt_to_local                     @ 297 NONAME
-	pj_time_local_to_gmt                     @ 298 NONAME
-	pj_time_val_normalize                    @ 299 NONAME
-	pj_timer_entry_init                      @ 300 NONAME
-	pj_timer_heap_cancel                     @ 301 NONAME
-	pj_timer_heap_count                      @ 302 NONAME
-	pj_timer_heap_create                     @ 303 NONAME
-	pj_timer_heap_destroy                    @ 304 NONAME
-	pj_timer_heap_earliest_time              @ 305 NONAME
-	pj_timer_heap_mem_size                   @ 306 NONAME
-	pj_timer_heap_poll                       @ 307 NONAME
-	pj_timer_heap_schedule                   @ 308 NONAME
-	pj_timer_heap_set_lock                   @ 309 NONAME
-	pj_timer_heap_set_max_timed_out_per_poll @ 310 NONAME
-	pj_unicode_to_ansi                       @ 311 NONAME
-	pj_utoa                                  @ 312 NONAME
-	pj_utoa_pad                              @ 313 NONAME
-	platform_strerror                        @ 314 NONAME
-	snprintf                                 @ 315 NONAME
-	vsnprintf                                @ 316 NONAME
+	pj_sockaddr_cmp                          @ 237 NONAME
+	pj_sockaddr_copy_addr                    @ 238 NONAME
+	pj_sockaddr_get_addr                     @ 239 NONAME
+	pj_sockaddr_get_addr_len                 @ 240 NONAME
+	pj_sockaddr_get_len                      @ 241 NONAME
+	pj_sockaddr_get_port                     @ 242 NONAME
+	pj_sockaddr_has_addr                     @ 243 NONAME
+	pj_sockaddr_in_get_addr                  @ 244 NONAME
+	pj_sockaddr_in_get_port                  @ 245 NONAME
+	pj_sockaddr_in_init                      @ 246 NONAME
+	pj_sockaddr_in_set_addr                  @ 247 NONAME
+	pj_sockaddr_in_set_port                  @ 248 NONAME
+	pj_sockaddr_in_set_str_addr              @ 249 NONAME
+	pj_sockaddr_init                         @ 250 NONAME
+	pj_sockaddr_print                        @ 251 NONAME
+	pj_sockaddr_set_port                     @ 252 NONAME
+	pj_sockaddr_set_str_addr                 @ 253 NONAME
+	pj_srand                                 @ 254 NONAME
+	pj_str                                   @ 255 NONAME
+	pj_strassign                             @ 256 NONAME
+	pj_strcat                                @ 257 NONAME
+	pj_strcat2                               @ 258 NONAME
+	pj_strcmp                                @ 259 NONAME
+	pj_strcmp2                               @ 260 NONAME
+	pj_strcpy                                @ 261 NONAME
+	pj_strcpy2                               @ 262 NONAME
+	pj_strdup                                @ 263 NONAME
+	pj_strdup2                               @ 264 NONAME
+	pj_strdup2_with_null                     @ 265 NONAME
+	pj_strdup3                               @ 266 NONAME
+	pj_strdup_with_null                      @ 267 NONAME
+	pj_strerror                              @ 268 NONAME
+	pj_stricmp                               @ 269 NONAME
+	pj_stricmp2                              @ 270 NONAME
+	pj_strltrim                              @ 271 NONAME
+	pj_strncmp                               @ 272 NONAME
+	pj_strncmp2                              @ 273 NONAME
+	pj_strncpy                               @ 274 NONAME
+	pj_strncpy_with_null                     @ 275 NONAME
+	pj_strnicmp                              @ 276 NONAME
+	pj_strnicmp2                             @ 277 NONAME
+	pj_strrtrim                              @ 278 NONAME
+	pj_strtoul                               @ 279 NONAME
+	pj_strtoul2                              @ 280 NONAME
+	pj_strtrim                               @ 281 NONAME
+	pj_symbianos_poll                        @ 282 NONAME
+	pj_symbianos_set_params                  @ 283 NONAME
+	pj_thread_create                         @ 284 NONAME
+	pj_thread_destroy                        @ 285 NONAME
+	pj_thread_get_name                       @ 286 NONAME
+	pj_thread_get_os_handle                  @ 287 NONAME
+	pj_thread_is_registered                  @ 288 NONAME
+	pj_thread_join                           @ 289 NONAME
+	pj_thread_local_alloc                    @ 290 NONAME
+	pj_thread_local_free                     @ 291 NONAME
+	pj_thread_local_get                      @ 292 NONAME
+	pj_thread_local_set                      @ 293 NONAME
+	pj_thread_register                       @ 294 NONAME
+	pj_thread_resume                         @ 295 NONAME
+	pj_thread_sleep                          @ 296 NONAME
+	pj_thread_this                           @ 297 NONAME
+	pj_time_decode                           @ 298 NONAME
+	pj_time_encode                           @ 299 NONAME
+	pj_time_gmt_to_local                     @ 300 NONAME
+	pj_time_local_to_gmt                     @ 301 NONAME
+	pj_time_val_normalize                    @ 302 NONAME
+	pj_timer_entry_init                      @ 303 NONAME
+	pj_timer_heap_cancel                     @ 304 NONAME
+	pj_timer_heap_count                      @ 305 NONAME
+	pj_timer_heap_create                     @ 306 NONAME
+	pj_timer_heap_destroy                    @ 307 NONAME
+	pj_timer_heap_earliest_time              @ 308 NONAME
+	pj_timer_heap_mem_size                   @ 309 NONAME
+	pj_timer_heap_poll                       @ 310 NONAME
+	pj_timer_heap_schedule                   @ 311 NONAME
+	pj_timer_heap_set_lock                   @ 312 NONAME
+	pj_timer_heap_set_max_timed_out_per_poll @ 313 NONAME
+	pj_unicode_to_ansi                       @ 314 NONAME
+	pj_utoa                                  @ 315 NONAME
+	pj_utoa_pad                              @ 316 NONAME
+	platform_strerror                        @ 317 NONAME
+	snprintf                                 @ 318 NONAME
+	vsnprintf                                @ 319 NONAME